;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to gen SiteList
;;;;;;;;;;;;;;;;;;
SQLgenSitelist:
$sSQL =
( 
   select distinct domain,
          sum(case type when 'B' then 1 else 0 end) bl,
          sum(case type when 'W' then 1 else 0 end) wl
   from tmp
   where type in ('B','W')
   and   item <> ''
   group by domain
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 512)

;;;;;;;;;;;;;;;;;;
;; <sp>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<sp>
)
Loop, Parse, $sResult, `n
{
   If (A_Index > 1)
   {
      StringSplit, $Field, A_LoopField, |
      Domain:=$Field1
      BL:=$Field2
      WL:=$Field3
      
;;;;;;;;;;;;;;;;;;
;; <m2filter d=domain
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%
	<m2filter d="%Domain%" version="1.0">
)

;;;;;;;;;;;;;;;;;;
;; <blacklist....item
;;;;;;;;;;;;;;;;;;
      $Working=B
      If BL > 0
      {
         GoSub SQLGetItem
      }
      Else
      {
$vSiteList=
(
%$vSiteList%<blacklist/>
)
      }

;;;;;;;;;;;;;;;;;;
;; <whitelist....item
;;;;;;;;;;;;;;;;;;
      $Working=W
      If WL > 0
      {
         GoSub SQLGetItem
      }
      Else
      {
$vSiteList=
(
%$vSiteList%<whitelist/>
)
      }

;;;;;;;;;;;;;;;;;;
;; </m2filter>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%</m2filter>
)

   }
}

;;;;;;;;;;;;;;;;;;
;; </sp>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%
</sp>
)

FileDelete SiteList.XML\SiteList.xml
FileAppend %$vSiteList%, SiteList.XML\SiteList.xml
Return

;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to retrieve blacklist/whitelist item
;;;;;;;;;;;;;;;;;;
SQLGetItem:
$sSQL =
( 
   select distinct '<item mode="' || regex || '">' || item || '</item>' rule
   from tmp
   where domain = '%DOMAIN%'
   and   type = '%$Working%'
   and   item <> ''
   order by regex, item;
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 512)

If $Working=B
{
$vSiteList=
(
%$vSiteList%<blacklist>
)
}
else
{
$vSiteList=
(
%$vSiteList%<whitelist>
)
}

Loop, Parse, $sResult, `n
If (A_Index > 1)
{
$vSiteList=
(
%$vSiteList%%A_LoopField%
)
}

If $Working=B
{
$vSiteList=
(
%$vSiteList%</blacklist>
)
}
else
{
$vSiteList=
(
%$vSiteList%</whitelist>
)
}

Return
