;;;
;;; SiteListUpdater by pekkle @ HKSAR
;;;
;;; It is to update the SiteList.xml for Maxthon 2 Beta
;;; by using Adblock Plus subscriptions filter list
;;;      http://adblockplus.org/en/subscriptions
;;;
;;; *** Please setup SiteListUpdater.ini to work properly ***
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; AutoHotkey Setting
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

;;;;;;;;;; From Default AHK
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#NoTrayIcon 
#SingleInstance IGNORE
SetBatchLines -1
Process Priority,,High

#Include ToRegEx.ahk
#Include XMLent.ahk
#Include GetMxInfo.ahk
#Include SQLite.ahk
#Include SetIEProxy.ahk
#Include ABP.ahk
#Include ProcessINI.ahk

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Locate the installed path of Maxthon2, and change working dir as plugin dir
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MxPath:=GetMxPath()

LastAccount:=GetMxLastAC(MxPath)
Lang:=GetMxLang(MxPath, LastAccount)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Main procedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UTF8BOM:=chr("0xEF") chr("0xBB") chr("0xBF")
Today := A_Now

;;;; Parameter processing
forceupdate =
setup =
unreg =
abpset =

GUIMsgBox(GetMsg("Param"))

Loop, %0%  ; For each parameter:
{
   param := %A_Index%  ; Fetch the contents of the variable whose name is contained in A_Index.
   
   ;-forceupdate
   ;-setup
   ;-unreg
   ;-u=abp:
   
   ;-h=xxxxxxxx
   ;-u=url
   ;-wie=xxxxxxx
   
   ; else.... param error
   If param = -forceupdate
      forceupdate = 1
   else if param = -setup
      setup = 1
   else if param = -unreg
      unreg = 1
   else if ( RegExMatch(param, "is)^\-u\=abp\:") = 1 )
      abpset = %param%
   else if ( RegExMatch(param, "is)^\-h\=") = 1 )
      wHnd := SubStr(param, 4)
   else if ( RegExMatch(param, "is)^\-u\=") = 1 )
      dummy=
   else if ( RegExMatch(param, "is)^\-wie\=") = 1 )
      wieHnd := SubStr(param, 6)
   else
   {
      GUIMsgBox(GetMsg("Param_err") " - " param)
      Sleep 1000
   }
}

;;; Remove abp:// handler
if unreg
{
  RemoveABP()
  ExitApp
}

;;; Check and setup abp:// handler
SetUpABP()

;;; Setup
if setup
{
   GoSub Setup
   ; End if cancel, or go to smart update for the new setting
   If SetupStatus=0
      GUIExit()
   Else
      forceupdate = 1   ;;; Force update after setup
}

FileCreateDir, SiteList.XML

if abpset ; ABP:// handling
   ABPSubscribe(abpset)
   
; Process SiteListUpdater.ini and build SiteList.xml
GUIMsgBox(GetMsg("StartUpd"))


FileDelete SiteList.DB
_SQLite_Startup()
$iRC := _SQLite_OpenDB("SiteList.DB")

$iRC := _SQLite_Exec($SQLITE_h_DB, "Create table usitelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create index iusitelist on usitelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create table nsitelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create index insitelist on nsitelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create table ositelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create index iositelist on ositelist (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create table tmp (filtername, lineno, txt, domain, type, regex, item);")
$iRC := _SQLite_Exec($SQLITE_h_DB, "Create index iotmp on otmp (filtername, lineno, txt, domain, type, regex, item);")

$iRC := _SQLite_Exec($SQLITE_h_DB, "begin transaction a;")

GoSub UpdateSiteList

GUIMsgBox(GetMsg("MergeXML"))
GoSub SQLgenSitelist
GoSub SQLgenFilter

GUIMsgBox(GetMsg("UpdXML"))
$iRC := _SQLite_Exec($SQLITE_h_DB, "commit transaction a;")
$iRC := _SQLite_Exec($SQLITE_h_DB, "vacuum;")

$iRC := _SQLite_CloseDB(-1)
$iRC := _SQLite_ShutDown()

;backup old filter set
FileCopy %MxPath%\Filter\SiteListUpdater.xml, %MxPath%\Filter\SiteListUpdater.backup1, True
FileCopy %MxPath%\Filter\SiteListUpdaterNoURL.xml, %MxPath%\Filter\SiteListUpdaterNoURL.backup1, True
FileCopy %MxPath%\%LastAccount%\Config\SiteList.xml, %MxPath%\%LastAccount%\Config\SiteList.backup1, True

;update filter
FileCopy SiteList.XML\SiteListUpdater.xml, %MxPath%\Filter\SiteListUpdater.xml, True
FileCopy SiteList.XML\SiteListUpdaterNoURL.xml, %MxPath%\Filter\SiteListUpdaterNoURL.xml, True
FileCopy SiteList.XML\SiteList.xml, %MxPath%\%LastAccount%\Config\SiteList.xml, True

GUIMsgBox(GetMsg("EndUpd"))
GUIExit()

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; End
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Sub procedure / function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#Include UpdateSiteList.ahk
#Include SQLgenSitelist.ahk
#Include SQLgenFilter.ahk
#Include GUIMsgBox.ahk
#Include GUISetup.ahk
#Include Grep.ahk
;;;;;;;;;;
;;; End
;;;;;;;;;;
