;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UpdateSiteList:
ProcessINI(MxPath)
;;; Process info in ini

Loop, %m2fidx%
{
    if M2profile_%A_Index% =
       continue
    
    RegExMatch(M2profile_%A_Index%, "is)([^\=]*?)\s*?\=\s*?(.*)", iniLinex)
    
    FilterName=
    FilterURL=
    FilterName=%iniLinex1%
    FilterURL=%iniLinex2%
    iniLinex1=
    iniLinex2=
    
    GUIMsgBox(GetMsg("StartUpd") " " FilterName)

    FileCreateDir, %FilterName%
    FileCopy %FilterName%\abp.txt, %FilterName%\abp_old.txt, True
    IniRead LastUpdate, %FilterName%\version.ini, Version, LastUpdate, 19000101000000
    
    ;download list
    If RegExMatch(FilterURL, "is)http\:\/\/") = 1
    {
       If ((forceupdate = 1) or (SubStr(LastUpdate, 1, 8) + 1 <= SubStr(Today, 1, 8)))
       {
           RunWait curl %Proxy% -D "%FilterName%\header" -o "%FilterName%\abp.txt" -z "%FilterName%\abp.txt" %FilterURL%,, Hide UseErrorLevel
           If ErrorLevel <> 0
           {
             GUIMsgBox(GetMsg("Fail") . " (" . FilterName . " )")
             Sleep 1000
           }
           Else
             IniWrite %Today%, %FilterName%\version.ini, Version, LastUpdate
       }
      
       ; Read Filter for checking
       FileRead nContents, %FilterName%\abp.txt
       
       
       ; Check if Valid ABP format           
       ;Header [Adblock..]
       ;;; (Adblock Plus 0.6.1.2 or higher required) [Adblock]
       ;;; [Adblock Plus 0.7.1]
       if ( RegExMatch(nContents, "is)^(?:" UTF8BOM ")?(?:\([^\)]*\)\s*?)?\[adblock") <> 1 )
       {
           nContents=
           FileCopy %FilterName%\abp.txt, %FilterName%\abp_error.txt, True
           FileCopy %FilterName%\abp_old.txt, %FilterName%\abp.txt, True
           Continue
       }
      
       ;Comment !
       ;;;;;;;;;;
       ;;; http://adblockplus.org/en/faq_internal
       ;;;
       ;;; ! This list expires after 5 days
       ;;; "expires after" or "expires:"
       ;;;
       ;;;;; ----- expire is ignored and check for update every times SiteListupdater start
              
       ;;;;;;;;;;
       ;;; http://adblockplus.org/development-builds/checksum-validation-for-subscription-downloads-added
       ;;;
       ;;; ! Checksum: abcd
       ;;; http://adblockplus.org/forum/viewtopic.php?t=2623
       ;;;
       ;;;;; ----- Validate Checksum
       if ( ABPCheckSumValidate(nContents) = false )
       {
;           GUIMsgBox("Checksum Error: " FilterName "!!!")
           MsgBox % "Checksum Error: " FilterName "!!!"
           Sleep 1000
           nContents=
           FileCopy %FilterName%\abp.txt, %FilterName%\abp_error.txt, True
           FileCopy %FilterName%\abp_old.txt, %FilterName%\abp.txt, True
           Continue
       }
       
       ;;;;;;;;;;
       ;;; ! Redirect: http://example.com/new_list.txt
       ;;; “redirect:” and “redirect to”
       ;;;
       ;;;;; ----- update redirect address of subscription
       RegExMatch(nContents, "is)(?:[\n]\!\s*?redirect\s*?(?:\:|to)\s*)([^\s]*)", sRedirectURL)
       sRedirectURL:=sRedirectURL1
       sRedirectURL1=
       if sRedirectURL<>
       {
          UTF8toASCII(sRedirectURL)
          
          FileRead sRedirectINI, SiteListUpdater.ini
          sRedirectINI2:=RegExReplace(sRedirectINI, "im)^(?:[\s]*)?" . ToRegEx(FilterName) . "(?:[\s]*)?\=.*$", FilterName . "=" . sRedirectURL ) 

          FileCopy SiteListUpdater.ini, SiteListUpdater.ini.bak, True
          FileDelete SiteListUpdater.ini
          FileAppend %sRedirectINI2%, SiteListUpdater.ini
       }

       ;;; Reset nContents for next subscription
       nContents=
    }
    else
    {
       FileCopy %FilterURL%, %FilterName%\abp.txt, True
       IniWrite %Today%, %FilterName%\version.ini, Version, LastUpdate
    }
    
    InsertSQL(FilterName, "abp_old.txt", "ositelist")
    InsertSQL(FilterName, "abp.txt", "nsitelist")
}

;;; UserList
Process_SiteList(MxPath . "\" . LastAccount . "\Config\SiteList.xml", "usitelist")

;;; Merge into tmp
$iRC := _SQLite_Exec($SQLITE_h_DB, "insert into tmp select '', 0, '', domain,  type, regex, item from usitelist where type in ('B', 'W') except select '', 0, '', domain, type, regex, item from ositelist where type in ('B', 'W') union select '', 0, '', domain, type, regex, item from nsitelist where type in ('B', 'W');")
$iRC := _SQLite_Exec($SQLITE_h_DB, "insert into tmp select * from usitelist where type = 'E' except select * from ositelist where type ='E' union select * from nsitelist where type = 'E';")

Return

;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;
InsertSQL(FilterName, FileName, TableName)
{
    Global UTF8BOM, $iRC, $SQLITE_h_DB

    ;;; Insert into SQLite Table
    Loop, read, %FilterName%\%FileName%
    {
      FilterTxt=%A_LoopReadLine%
      FilterTxt := RegExReplace(FilterTxt, "is)^\s*" UTF8BOM, "")
      FilterTxt:=RegExReplace(FilterTxt, "is)'", "''")
      
      TxtDomain =
      TxtType =
      TxtRegEx =
      TxtItem =

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;Empty Line
      If FilterTxt =
      {
        ;;; Nothing to Do, to be ignored
        TxtType = X
      }    
      ;Header [Adblock..]
      ;;; (Adblock Plus 0.6.1.2 or higher required) [Adblock]
      ;;; [Adblock Plus 0.7.1]
      Else If ( RegExMatch(FilterTxt, "is)^(?:" UTF8BOM ")?(?:\([^\)]*\)\s*?)?\[adblock") = 1 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = H
      }
      ;Comment !
      ;;;;;;;;;;
      ;;; http://adblockplus.org/en/faq_internal
      ;;;
      ;;; ! This list expires after 5 days
      ;;; “expires after” or “expires:”
      ;;; ... Could be ignore and check for update every times SiteListupdater start
      ;;;
      ;;;;;;;;;;
      ;;; ! Redirect: http://example.com/new_list.txt
      ;;; “redirect:” and “redirect to”
      ;;;
      ;;;;;;;;;;
      ;;; http://adblockplus.org/development-builds/checksum-validation-for-subscription-downloads-added
      ;;;
      ;;; ! Checksum: abcd
      ;;; http://adblockplus.org/forum/viewtopic.php?t=2623
      Else If ( RegExMatch(FilterTxt, "is)^\!") = 1 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = !
      }
      ;CSS ##
      Else If ( RegExMatch(FilterTxt, "is)##") > 0 )
      {
        ;;; Nothing to Do, to be ignored
        TxtType = C
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;Element Hiding #
      Else If ( RegExMatch(FilterTxt, "is)#") > 0 )
      {
        TxtType = E
        
        ;MatchURL
        RegExMatch(FilterTxt, "is)[^\#]*", TxtDomain)
        TxtDomain := ToRegEx(TxtDomain)
        
        if instr(TxtDomain, "\,") > 0
        {
           TxtDomain := "(?:" RegExReplace(TxtDomain, "\\\,", "|") ")"
        }
        TxtDomain:=XMLent(TxtDomain)

        ;bound
        RegExMatch(FilterTxt, "is)(?<=\#)[^\(]*", TxtRegEx)
        TxtRegEx := TxtRegEx = "*" ? "[^\/]" : ToRegEx(TxtRegEx)
        TxtRegEx :=XMLent("\<" TxtRegEx "[^\>]*?\>")
        
        ;match
        Grep(FilterTxt, "is)(\([^\)]*\))", TxtItem)
        StringSplit, TxtItem, TxtItem, % chr(4)
        TxtItem=

        ; No () e.g. slate.com#hr
        If TxtItem0 = 0
           TxtItem:=RegExReplace(TxtRegEx, ".{15}$", "")
        Else
        {
          Loop, %TxtItem0%
          {
            tmpstr3=
            RegExMatch(TxtItem%A_Index%, "is)(?<=\()([^\=\)]*)(?:\=)*([^\)]*)", tmpstr)

            ; No = in () rule e.g. 163.com#DIV(adMenu)  
            If tmpstr2=
            {
;              tmpstr3 := "[^\s]*?\s*?\=\s*?$STR(" ToRegEx(tmpstr1) ")"
              tmpstr3 := "[^\s]*?\s*?\=\s*?(?:""" ToRegEx(tmpstr1) """|'" ToRegEx(tmpstr1) "'|" ToRegEx(tmpstr1) "(?=[\s>'""]))"

              TxtItem := TxtItem . tmpstr3 . "|"

              If A_Index = 1
                TxtRegEx := RegExReplace(TxtRegEx, "\[\^\\\&gt\;\]\*\?\\\&gt\;$", "[^\&gt;]*?" XMLent(ToRegEx(tmpstr1)) "[^\&gt;]*?\&gt;")
            }
            Else
            {
              If A_Index = 1
                TxtRegEx := RegExReplace(TxtRegEx, "\[\^\\\&gt\;\]\*\?\\\&gt\;$", "[^\&gt;]*?" XMLent(ToRegEx(RegExReplace(tmpstr1, "[\^|\$|\*]$", ""))) "[^\&gt;]*?\=[^\&gt;]*?" XMLent(ToRegEx(tmpstr2)) "[^\&gt;]*?\&gt;")
              ;; ^=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\^$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\^$", "")) "\s*?\=\s*?$STR(" ToRegEx(tmpstr2) ".*?)" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\^$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\^$", "")) "\s*?\=\s*?(?:""" ToRegEx(tmpstr2) "[^""]*?""|'" ToRegEx(tmpstr2) "[^']*?'|" ToRegEx(tmpstr2) "[^\s>'""]*?(?=[\s>'""]))": "")
              ;; $=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\$$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\$$", "")) "\s*?\=\s*?$STR(.*?" ToRegEx(tmpstr2) ")" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\$$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\$$", "")) "\s*?\=\s*?(?:""[^""]*?" ToRegEx(tmpstr2) """|'[^']*?" ToRegEx(tmpstr2) "'|[^\s>'""]*?" ToRegEx(tmpstr2) "(?=[\s>'""]))": "")
              ;; *=
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\*$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\*$", "")) "\s*?\=\s*?$STR(.*?" ToRegEx(tmpstr2) ".*?)" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "\*$") > 0 ? ToRegEx(RegExReplace(tmpstr1, "\*$", "")) "\s*?\=\s*?(?:""[^""]*?" ToRegEx(tmpstr2) "[^""]*?""|'[^']*?" ToRegEx(tmpstr2) "[^']*?'|[^\s>'""]*?" ToRegEx(tmpstr2) "[^\s>'""]*?(?=[\s>'""]))": "")
              ;; =
;              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "[\^|\$\*]$") = 0 ? ToRegEx(tmpstr1) "\s*?\=\s*?$STR(" ToRegEx(tmpstr2) ")" : "")
              tmpstr3 := tmpstr3 . (RegExMatch(tmpstr1, "[\^|\$\*]$") = 0 ? ToRegEx(tmpstr1) "\s*?\=\s*?(?:""" ToRegEx(tmpstr2) """|'" ToRegEx(tmpstr2) "'|" ToRegEx(tmpstr2) "(?=[\s>'""]))": "")
              
              TxtItem := TxtItem . tmpstr3 . "|" 
            }
          }
  
          ; Remove last |
          TxtItem:=RegExReplace(TxtItem, "\|$", "")

          ; For more than 1 () rule e.g. 3quote.info#TD(width=364)(height=280)  
          if TxtItem0 > 1
            TxtItem:="(?:(?:" . TxtItem . ").*?){" TxtItem0 "}"
  
          TxtItem:=XMLent(TxtItem)
        }
        TxtItem:="(" TxtItem ")"
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;WhiteList @@
      Else If ( RegExMatch(FilterTxt, "is)^@@") = 1 )
      {
        TxtDomain = *
        TxtType = W
        TxtRegEx := RegExMatch(FilterTxt, "is)^@@\/.*\/$") > 0 ? 1 : 0
        If TxtRegEx = 1
        {
          ;;; @@
          TxtItem := RegExReplace(FilterTxt, "is)^@@", "")
          ;;; /.../
          TxtItem := RegExReplace(TxtItem, "is)^\/", "")
          TxtItem := RegExReplace(TxtItem, "is)\/$", "")
        }
        Else
        {
          ;;; @@
          TxtItem := RegExReplace(FilterTxt, "is)^@@", "")
          ;;; Remove filter options $, ********* Not support in Maxthon2 *********
          TxtItem := RegExMatch(TxtItem, "is)\$") > 0 ? "" : TxtItem
          If RegExMatch(TxtItem, "is)^\|") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\|$") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\?") > 0
            TxtRegEx = 1

          If TxtRegEx = 1
            TxtItem := ToRegEx(TxtItem)
            
          TxtItem := RegExReplace(TxtItem, "is)^\.\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\.\*$", "")
          TxtItem := RegExReplace(TxtItem, "is)^\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\*$", "")
        }
        TxtItem := XMLent(TxtItem)
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;BlackList
      Else
      {
        TxtDomain = *
        TxtType = B
        TxtRegEx := RegExMatch(FilterTxt, "is)^\/.*\/$") > 0 ? 1 : 0
        If TxtRegEx = 1
        {
          ;;; /.../
          TxtItem := RegExReplace(FilterTxt, "is)^\/", "")
          TxtItem := RegExReplace(TxtItem, "is)\/$", "")
        }
        Else
        {
          ;;; Remove filter options $, ********* Not support in Maxthon2 *********
          TxtItem := RegExMatch(FilterTxt, "is)\$") > 0 ? "" : FilterTxt
          If RegExMatch(TxtItem, "is)^\|") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\|$") > 0
            TxtRegEx = 1
          If RegExMatch(TxtItem, "is)\?") > 0
            TxtRegEx = 1

          If TxtRegEx = 1
            TxtItem := ToRegEx(TxtItem)
            
          TxtItem := RegExReplace(TxtItem, "is)^\.\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\.\*$", "")
          TxtItem := RegExReplace(TxtItem, "is)^\*", "")
          TxtItem := RegExReplace(TxtItem, "is)\*$", "")
        }
        TxtItem := XMLent(TxtItem)
      }
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      ;;SQL
      $iRC := _SQLite_Exec($SQLITE_h_DB, "insert into " TableName " values ('" XMLent(FilterName) "', " A_Index ", '" XMLent(FilterTxt) "', '" TxtDomain "', '" TxtType "', '" TxtRegEx "', '" TxtItem "');")
    }
  Return
}

;;;;;;;;;;;;;;;;;;
;; break sitelist.xml and insert into SQLite tables
;;;;;;;;;;;;;;;;;;

Process_SiteList(filename, tablename)
{
  Global $SQLITE_h_DB
  FileRead,XML,%filename% 

;  XML:=RegExReplace(XML, "is)(\t|\r|\n)", "")
  Grep(XML, "is)\<m2filter.*?\<\/m2filter\>", m2filter)
  StringSplit, m2filter, m2filter, % chr(4)
   
   ;--- For every entry of <m2filter.....</m2filter>
   Loop
   {
      if m2filter%A_Index% =
         break
      
      RegExMatch(m2filter%A_Index%, "is)\<m2filter.*?d\=\""(.*?)\""", Domain)
      Domain:=Domain1
      Domain1=
   
      ;---------- blacklist
      RegExMatch(m2filter%A_Index%, "is)(\<blacklist(\s*?\/\>|.*?\<\/blacklist\>))", filterList)
      blackwhite=B
      filterList:=filterList1
      filterList1=
      Process_list(Domain, blackwhite, filterList, tablename)

      ;---------- whitelist
      RegExMatch(m2filter%A_Index%, "is)(\<whitelist(\s*?\/\>|.*?\<\/whitelist\>))", filterList)
      blackwhite=W
      filterList:=filterList1
      filterList1=
      Process_list(Domain, blackwhite, filterList, tablename)
   }
}

;;;;;;;;;;;;;;;;;;
;; break item
;;;;;;;;;;;;;;;;;;
Process_list(Domain, blackwhite, filterList, tablename)
{
  Global $iRC, $SQLITE_h_DB
  Grep(filterList, "is)\<item.*?\<\/item\>", filterList)
  StringSplit, filterList, filterList, % chr(4)
  
  Loop
  {
     if filterList%A_Index% =
        break
        
     RegExMatch(filterList%A_Index%, "is)\<item.*?mode\=\""(.*?)\"".*?\>([^<]*)", item)

     ;--- If rules exists in new version then ignore
     $iRC := _SQLite_Exec($SQLITE_h_DB, "insert into " tablename " values ('', 0, '', '" Domain "','" blackwhite "','" item1 "','" item2 "');")      
  }
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;--- validate checksum of subscribed filter
#include MD5.ahk
#include ChgCP.ahk
ABPCheckSumValidate(nContents)
{
  ;Change to ANSI for processing
  nContents:=UTF82ANSI(nContents)
  
  ;Get existing checksum for validation
  RegExMatch(nContents, "is)(?:[\n]\!\s*?Checksum[\s\-:]+\s*)([^\s]*)", chksum)
  chksum:=chksum1
  chksum1=
  
  ; If no checksum exists, no need to validate
  if chksum=
    Return true
    
  ;;; Normalize
  ;Remove already existing checksum
  nContents:=RegExReplace(nContents, "is)(?:[\n]\!\s*?Checksum[\s\-:]+\s*)([^\s]*)", "")

  ;Calculate new checksum: remove all CR symbols and empty
  ;lines and get an MD5 checksum of the result (base64-encoded,
  ;without the trailing = characters).
  nContents:=RegExReplace(nContents, "is)\r", "")
  nContents:=RegExReplace(nContents, "is)\n+", "`n")
  
  ;Change back to UTF-8 for checksum generation
  nContents:=ANSI2UTF8(nContents)
  
  ;Get MD5 Hash
  MD5Hash:=MD5(nContents, StrLen(nContents))
  
  ; Get MD5-Base64 Hash
  MD5Hash_Base64:=MD5_Base64(nContents, StrLen(nContents))
  Return (MD5Hash_Base64 = chksum) ? true : false
}
